#include <stdio.h>
#include <stdlib.h>
#include <string.h>


struct haftree {
	int num ;
	int h ;
	char *code;
	unsigned char symb;
	struct haftree *father;
	struct haftree *lson;
	struct haftree *rson;
};

struct line{
	unsigned char ch;
	char *code;
	};
struct haftree *root = (struct haftree*)malloc(sizeof(struct haftree));

void treebuild (int *A , int L)
{
	int j=0;
	int pos1=0, pos2=0;
	int k = 0;
	struct haftree *mas[256];
	for (int i = 0 ; i < 256 ; i ++)
	{
		mas[i] = (struct haftree*)malloc(sizeof(struct haftree));
		mas[i]->code = (char*)malloc(sizeof(char*));
		mas[i]->h = 0;
		mas[i]->lson = NULL;
		mas[i]->rson = NULL;
		mas[i]->father = NULL;
	}
	root->father = NULL;
	root->lson = NULL;
	root->rson = NULL;
	root->num = 0;
	struct haftree *p = (struct haftree*)malloc(sizeof(struct haftree));
	p = root;
	struct haftree *min1 = mas[0], *min2 = mas[0];
	for (int i = 0 ; i < 256 ; i++)
	{
		if (A[i]>0)
		{
		mas[k]->num = A[i];
		mas[k]->symb = i;
		k++;
		}
	}
	j = L - 1 ;
	struct haftree * key = (struct haftree*)malloc(sizeof(struct haftree));
	for (int x = 0 ; x < L-1 ; x++)
	{
	for (int i = L ; i > 0 ; i--)
	{
		for (int z = 0 ; z < L - 1 ; z++)
		{
			if (mas[z]->num < mas[z+1]->num) 
			{
				key = mas[z];
				mas[z] = mas[z+1];
				mas[z+1] = key;
			}
		}
	}
	pos1 = j;
	pos2 = j-1;
	min1 = mas[pos1];
	min2 = mas[pos2];
	struct haftree *newel = (struct haftree*)malloc(sizeof(struct haftree));
	newel->code = (char*)malloc(sizeof(char*));
	newel->lson = min2;
	newel->rson = min1;
	newel->num = min1->num + min2->num ; 
	newel->h = 0;
	mas[pos1] = newel;
	min1->father = mas[pos1];
	min2->father = mas[pos1];
	j--;
	}
	root = mas[pos1]; 
}

void prefix (haftree *curr , char **A , int last)
{	
	if (curr != root)
	{
		strcpy(curr->code , curr->father->code);
		if (last == 0) 
			curr->code[curr->h - 1] = '0';
		else
			curr->code[curr->h - 1] = '1';
	}
	if (!(curr->lson))
	{
		strcpy( A[curr->symb] , curr->code );
        return;
	}
	curr->lson->h = curr->h + 1;
	curr->rson->h = curr->h + 1;
    prefix(curr->lson , A  , 0);
    prefix(curr->rson , A  , 1);

}

void arch(char *fname , char *fnewname)
{
	printf("starting...\n");
	char ** end =(char**)malloc(sizeof(char*));
	int mas[256];
	int chnum = 0 , n = -1;
	char *code =(char*) malloc(sizeof(char)*256);
	strcpy(code , "\0");
	char *codemas[256];
	for (int i = 0 ; i < 256 ; i++)
	{
		codemas[i] =(char*) malloc(sizeof(char*));
		strcpy(codemas[i] , "\0");
	}
	int length = 0;
	unsigned char ch;
		FILE *f = fopen(fname,"rb");
		if (!f)
		return ;
		/*    */
		for (int i = 0 ; i < 256 ; i++)
		{
			mas[i]=0;
		}
		while ( fread( &ch , sizeof(unsigned char) , 1 , f) >= 1 )
			mas[ch]++;
		for (int i = 0 ; i < 256 ; i ++)
			if ( mas[i] > 0 ) chnum++;
		for (int i = 0 ; i < 256 ; i++)
			length += mas[i];
		fclose (f);
		/*******************************/
		treebuild(mas , chnum); // 
		prefix (root , codemas , 0 ); //  
		FILE *newf = fopen(fnewname,"wb");
		//////////////
		fprintf(newf , "%d " , length);
		fprintf(newf , "%d" , chnum);
		/* */
		printf("compressing...\n");
		for (int i = 0 ; i < 256 ; i++)
		{
			if (mas[i] > 0)
			{
			fwrite(&i , 1 , 1 , newf );
			char j = 0;
			while ((codemas[i][j] == '1' )||(codemas[i][j] == '0' ))
				j++;
			fwrite ( &j ,1 ,1 , newf);
			j =0;
			while ((codemas[i][j] == '1' )||(codemas[i][j] == '0' ))
			{
				fwrite(&codemas[i][j] , 1 , 1 , newf);
				j++;
			}
			}
		}
		/*-----------------*/
		f = fopen(fname,"rb");
		char *string;
		char *strlast;
		strlast =(char*)malloc (sizeof(char)*length*12);
		string =(char*)malloc (sizeof(char)*length*12);
		strcpy(string , "\0");
		/**/
		int pysh_pysh_pysh = 0;
		while ( fread( &ch , sizeof(char) , 1 , f) >= 1 )
		{
			if(pysh_pysh_pysh > 2558000)
				printf("\n\n   ---\ncurrent=%10d\nvalue='%c'\n", pysh_pysh_pysh++, ch);
			else
				pysh_pysh_pysh=0;

			int i = 0;
			while (( codemas[ch][i] == '0' )||(codemas[ch][i] == '1'))
			{
if(pysh_pysh_pysh > 2558000)  printf("i=%d\n", i);
				i++;
			}
			//strcpy(string, ""); // i think, it must be here
if(pysh_pysh_pysh > 2558000) printf("step 1\n");
			strncat( string , codemas[ch] , i );
if(pysh_pysh_pysh > 2558000) printf("step 2\n");
			strcpy(code , "\0");

if(pysh_pysh_pysh > 2558000) printf("i'm here\n");
			i = 0;
			while (( string[i] == '0' )||(string[i] == '1'))
				i++;
if(pysh_pysh_pysh > 2558000) printf("but now i'm here\n");
			while ((i - 8) >= 0)
			{
				i = i - 8;
				strncpy(code , string , 8 );
				n = strtoul(code , end , 2 );
				string+=8;
if(pysh_pysh_pysh > 2558000) printf("before write\n");
				fprintf( newf , "%c" , n );
if(pysh_pysh_pysh > 2558000) printf("after write\n");
			}
		}
		int x = 0;
		while (( string[x] == '0' )||(string[x] == '1'))
				x++;
		for (int k = x ; k < 8 ; k++)
			string[k] = '0';
		strncpy(code , string , 8 );
		n = strtoul(code , end , 2 );
		string+=8;
		fprintf( newf , "%c" , n );
}

struct haftree *restoretree(struct line **A , int chnum)
{
	struct haftree *curr = (struct haftree*)malloc(sizeof(struct haftree));
	if(curr == NULL)
	{
		perror("omg");
		return NULL;
	}
	curr->h = 0 ;
	curr->num = 0;
	curr->lson = NULL;
	curr->rson = NULL;
	struct haftree *head = curr;
	for (int i = 0 ; i < chnum ; i++)
	{
		while (( A[i]->code[0] == '1' )||( A[i]->code[0] == '0' ))
		{
			struct haftree *newel = (struct haftree*)malloc(sizeof(struct haftree));
			newel->lson = NULL;
			newel->rson = NULL;
			newel->h = curr->h + 1;
			newel->num = 0;
			newel->father = curr;
			if (A[i]->code[0] == '1')
			{
				if (!curr->rson)
					curr->rson = newel;
				curr = curr->rson;
			}
			else if (A[i]->code[0] == '0')
			{
				if (!curr->lson)
					curr->lson = newel;
				curr = curr->lson;
			}
			A[i]->code += 1;
		}
		curr->symb = A[i]->ch;
		curr = head;
	}
return head;
}

void dearch (char *fname , char *fnewname)
{
printf("fuck\n");
	char *string =(char*)malloc(sizeof(char*));
	int chnum;
	int length;
	int code;
	unsigned char symb;
	struct line *mas[256];
	for (int i = 0 ; i < 256 ; i++)
		mas[i] = (struct line *)malloc(sizeof(struct line *));
	struct haftree *root;
	struct haftree *curr;
	FILE * f = fopen(fname , "rb");	
	if(f == NULL)
	{
		perror("AAA!!!111adinadin");
		return ;
	}
	fscanf ( f , "%d" , &length );
	fscanf ( f , "%d" , &chnum );
	for (int i = 0 ; i < 256 ; i++ )
	{
		mas[i]->ch =(unsigned char)malloc(sizeof(unsigned char));
		mas[i]->code =(char*)malloc(sizeof(char*));
	}
	int number;
	unsigned char l ;
	//int l = 0;
	for (int i = 0 ; i < chnum ; i++)
	{
		fread ( &mas[i]->ch , sizeof(char) , 1 , f);
		fread ( &l , sizeof(char) , 1 , f);
		for (unsigned char z = 0 ; z < l ; z++)
			fread (&mas[i]->code[z] , sizeof(char) , 1 , f);
	}
	FILE * newf = fopen(fnewname , "wb");
	root = restoretree(mas , chnum);
	curr = root;
	int  k = 0;
	int num = 1;
	unsigned char buff;
	//fscanf(f , "%c" , &symb);
	//fscanf(f , "%c" , &symb);
	fread (&symb , sizeof(char) , 1 , f);
	buff = symb;
printf("fuck fuck\n");
	do
	{
		printf("k=%d\n", k);
		while (curr->rson)
		{
			if(num > 8)
			{
				fread (&symb , sizeof(char) , 1 , f);
				num = 1;
				buff = symb;
			}

			if ((buff >> (8-num))&1)
			{
				curr = curr->rson;
				num++;
			}
			else 
			{
				curr = curr->lson;
				num++;
			}
		}
		fwrite(&(curr->symb) , sizeof(char) , 1 , newf);
			curr = root;
			k++;
	}while (k < length);
////////////////////
}


